Loading...
Searching...
No Matches
juce::IIRFilterAudioSource Class Reference

## Detailed Description

An AudioSource that performs an IIR filter on another source.

The documentation for this class was generated from the following file:

- juce_audio_basics/sources/juce_IIRFilterAudioSource.h

Inheritance diagram for juce::IIRFilterAudioSource:

## Public Member Functions

| IIRFilterAudioSource (AudioSource *inputSource, bool deleteInputWhenDeleted)
| Creates a IIRFilterAudioSource for a given input source.
| ~IIRFilterAudioSource () override
| Destructor.
void | setCoefficients (const IIRCoefficients &newCoefficients)
| Changes the filter to use the same parameters as the one being passed in.
void | makeInactive ()
| Calls IIRFilter::makeInactive() on all the filters being used internally.
void | prepareToPlay (int samplesPerBlockExpected, double sampleRate) override
| Tells the source to prepare for playing.
void | releaseResources () override
| Allows the source to release anything it no longer needs after playback has stopped.
void | getNextAudioBlock (const AudioSourceChannelInfo &) override
| Called repeatedly to fetch subsequent blocks of audio data.
Public Member Functions inherited from juce::AudioSource
virtual | ~AudioSource ()=default
| Destructor.

## Additional Inherited Members

Protected Member Functions inherited from juce::AudioSource
| AudioSource ()=default
| Creates an AudioSource.

## Constructors and Destructors

## IIRFilterAudioSource()

juce::IIRFilterAudioSource::IIRFilterAudioSource | ( | AudioSource * | inputSource,
|  | bool | deleteInputWhenDeleted )

Creates a IIRFilterAudioSource for a given input source.

Parameters

  inputSource | the input source to read from - this must not be null
  deleteInputWhenDeleted | if true, the input source will be deleted when this object is deleted

References juce::AudioSource::AudioSource().

Referenced by getNextAudioBlock().

## ~IIRFilterAudioSource()

juce::IIRFilterAudioSource::~IIRFilterAudioSource | ( |  | ) |

override

Destructor.

## Member Functions

## setCoefficients()

void juce::IIRFilterAudioSource::setCoefficients | ( | const IIRCoefficients & | newCoefficients | ) |

Changes the filter to use the same parameters as the one being passed in.

## makeInactive()

void juce::IIRFilterAudioSource::makeInactive | ( |  | ) |

Calls IIRFilter::makeInactive() on all the filters being used internally.

## prepareToPlay()

void juce::IIRFilterAudioSource::prepareToPlay | ( | int | samplesPerBlockExpected,
|  | double | sampleRate )

override virtual

Tells the source to prepare for playing.

An AudioSource has two states: prepared and unprepared.

The prepareToPlay() method is guaranteed to be called at least once on an 'unprepared' source to put it into a 'prepared' state before any calls will be made to getNextAudioBlock(). This callback allows the source to initialise any resources it might need when playing.

Once playback has finished, the releaseResources() method is called to put the stream back into an 'unprepared' state.

Note that this method could be called more than once in succession without a matching call to releaseResources(), so make sure your code is robust and can handle that kind of situation.

Parameters

  samplesPerBlockExpected | the number of samples that the source will be expected to supply each time its getNextAudioBlock() method is called. This number may vary slightly, because it will be dependent on audio hardware callbacks, and these aren't guaranteed to always use a constant block size, so the source should be able to cope with small variations.
  sampleRate | the sample rate that the output will be used at - this is needed by sources such as tone generators.

See also
  releaseResources, getNextAudioBlock

Implements juce::AudioSource.

## releaseResources()

void juce::IIRFilterAudioSource::releaseResources | ( |  | ) |

override virtual

Allows the source to release anything it no longer needs after playback has stopped.

This will be called when the source is no longer going to have its getNextAudioBlock() method called, so it should release any spare memory, etc. that it might have allocated during the prepareToPlay() call.

Note that there's no guarantee that prepareToPlay() will actually have been called before releaseResources(), and it may be called more than once in succession, so make sure your code is robust and doesn't make any assumptions about when it will be called.

See also
  prepareToPlay, getNextAudioBlock

Implements juce::AudioSource.

## getNextAudioBlock()

void juce::IIRFilterAudioSource::getNextAudioBlock | ( | const AudioSourceChannelInfo & | bufferToFill | ) |

override virtual

Called repeatedly to fetch subsequent blocks of audio data.

After calling the prepareToPlay() method, this callback will be made each time the audio playback hardware (or whatever other destination the audio data is going to) needs another block of data.

It will generally be called on a high-priority system thread, or possibly even an interrupt, so be careful not to do too much work here, as that will cause audio glitches!

See also
  AudioSourceChannelInfo, prepareToPlay, releaseResources

Implements juce::AudioSource.

References IIRFilterAudioSource().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited